/*		Emulator XF551  na  ATARI 1040 STE		*/

#include <stdio.h>
#include <tos.h>
#include <stdlib.h>
#include <string.h>
#include "d:geminit.h"
#include "d:xf551.h"

#define MAX_BUF		(8*1024)
#define MAX_RAM		(360*1024L)
#define MAX_TRACK	(12*512)
#define DISK3_INFO	9		/* sektor 9 , stopa 0 , strana 0 */
#define ZAC_NAM		256		/* sektor+256 <- nazvy diskov	 */

#define DATA_OK		67
#define CMD_OK		65
#define DATA_ERR	69
#define NO_CMD		78

#define DELAY_SEL	0x2000
#define POVEL_TIMEOUT	0x3L	/*0x7800L*/	/* 0x100L */
#define TIMEOUT		0x20000L
#define WAIT1_19	17
#define WAIT2_19	10
#define WAITP_19	0
#define WAIT_19		28
#define WAITS_19	3
#define WAIT1_38	6
#define WAIT2_38	2
#define WAITP_38	2
#define WAIT_38		10
#define WAITS_38	2
#define RES_BPS( x )	((x)>4?(x):(x)==0?(128):(x)*256)
#define BACK_SEC( x )	((x)<256?(x):(x)>>8)
#define LENGH_SEC( x )	((x)==128?(0):(x)>>8)
#define SECTORS( x )	((x)==0?(0):(x)<10?9:(x)<19?18:(x)<27?26:(x))
#define min(a,b)	((a)<(b)?(a):(b))
#define max(a,b)	((a)>(b)?(a):(b))

typedef unsigned char byte;

typedef struct {	long timeout;		/* pri receive */
					int  wait2, wait1;	/* pri send iba wait1 */
					char *buf;			/* adr. */
					int bit,			/* naraznik  send:$100, rec:$80 */
						size,			/* dlzka >0 ! */
						waitp;			/* jemny wait */
				} t_sio;

typedef struct {	int disk,track,sector,count;
				} t_sektor;

OBJECT *t_main,*t_format,*t_if_frm,*t_iindsk,*t_seldx,*t_chnam,*t_error;

void (*trap_old_vect)();
void (*busy_old_vect)();
int mbuf[8];
int	mx,my,mw,mh,cd3,cs5;
byte ram_stat, disk3_stat, disk5_stat;
int	disk3[9][8],
	disk5[2][4],
	diskr[4],
	tab_dx[3],
	write_protect[3],
	speedy[3],
	prdisk[4],
	p3disk[4],
	disk_track[2];
byte gl_pom;

int povel=0;
int select_B=0;
unsigned delay_sel=0;	/* delay pre unselect B */
int gl_psw;
int tr_3p=-1;
int disk3_minsek=0;
int disk3_maxsek=0;
int disk3_wrtrack=0;
int disk5_max=0;
unsigned long rd_free;
byte disk3_name[9][17];
byte *bufer;
byte *tr_3buf;	/* bufer pre stopu DISK3 */
byte *ramdisk;
byte povel_buf[6], odpoved=CMD_OK;
t_sektor gl_doc;
t_sio povel_sio= { POVEL_TIMEOUT,WAIT2_19,WAIT1_19,povel_buf,0x80,5,WAITS_19 };
t_sio sio_r={TIMEOUT,WAIT2_19,WAIT1_19,0L,0x80,5,WAITS_19};
t_sio sio_s={TIMEOUT,WAIT2_19,WAIT_19,0L,0x100,5,WAITS_19};
t_sio sio_odpov={TIMEOUT,WAIT2_19,WAIT_19,&odpoved,0x100,1,WAITS_19};

/*-----deklaracie-----*/

long trap_0( int func, long val, void *adr );
void int_povel( void );			/** def. v XF551_IO.S **/
int sio_send( t_sio *t );
int sio_receive( t_sio *t );

void valtostr( unsigned long val, char *str, int n );
void obj_sval( OBJECT *o, long val );
int obj_do( OBJECT *t, int start_o );
void obj_select( OBJECT *o , int s );
int inic( char *fn );

void error(char *t);
void dx_select(int x,OBJECT *p, int bt);
void select3(int x);
void select5(int x);
void read3( void );
void read5( void );
void vypis3( void );
void vypis5( void );
void vypisr( void );
void format3( void );
void name3( void );
int do_main( int obj );

byte check_sum( byte *buf, int dl);

/*-----funkcie------*/

#define wait( w )	{ unsigned i=(w); while( i-- ); }

unsigned long MULu( unsigned a, unsigned b ) 0xC0C1;
unsigned int DIVu( unsigned long a, unsigned b ) 0x80C1;
unsigned long DIV_MOD( unsigned long a, unsigned b ) 0x80C1;
unsigned long SWAP( unsigned long ) 0x4840;
long TRAP_0( int func, long val, void *adr ) 0x4E40;

#define	F_READ_B	0x8000	/* move.b (a0),d0 */
#define	F_READ_W	0x8001	/* move.w (a0),d0 */
#define	F_READ_L	0x8002	/* move.l (a0),d0 */
#define	F_WRITE_B	0x8004	/* move.b d1,(a0) */
#define	F_WRITE_W	0x8005	/* move.w d1,(a0) */
#define	F_WRITE_L	0x8006	/* move.l d1,(a0) */
#define F_SUPEXEC	0xABCD	/* jsr (a0) */

void move_to_sr( int status )	0x46c0;
int move_sr( void )	0x40c0;

void vector_enable( void )
{	trap_old_vect= Setexc( 32, (void(*)())trap_0 );	/* trap #0 */
	busy_old_vect= Setexc( 64, int_povel );		/* Centronics BUSY */
	TRAP_0( F_WRITE_B, TRAP_0( F_READ_B,0L,(void(*)())0xfffa03L ) & 0xfeL, (void(*)())0xfffa03L );
	Jenabint( 0 );								/* enable int BUSY */
}

void vector_disable( void )
{	Setexc( 32, trap_old_vect );	/* trap #0 vrati povodny */
	Setexc( 32, busy_old_vect );	/* int BUSY vrati povodny */
	Jdisint( 0 );					/* disable int BUSY */
}

#define vbl_on		TRAP_0( F_WRITE_W, 1, (void *)0x452 )
#define vbl_off		TRAP_0( F_WRITE_W, 0, (void *)0x452 )

#define ikbd_on		{ byte ikbd=0x11; Ikbdws( 1-1, &ikbd ); }
#define ikbd_off	{ byte ikbd=0x13; Ikbdws( 1-1, &ikbd ); }

long super_exec( long (*adresa)(), long val )
{	return ( TRAP_0( F_SUPEXEC, val, adresa ) );
}
/*
void int_off_s( void )
{	move_to_sr( ( gl_psw=move_sr() ) | 0x700 );
}

void int_on_s( void )
{	move_to_sr( gl_psw );
}

void int_off( void )
{	TRAP_0( F_SUPEXEC, 0, int_off_s );
}

void int_on( void )
{	TRAP_0( F_SUPEXEC, 0, int_on_s );
}
*/
void valtostr( unsigned long val, char *str, int n )
{
	for( ; n--; val/=10U )
		str[n]= '0' + (unsigned)(val % 10U);
}

long obj_val( OBJECT *o )
{ TEDINFO *ted = o->ob_spec.tedinfo;
  static char str[40];		/* ## */
  char  *t=ted->te_ptext,
		*m=ted->te_ptmplt;
  int i=0, j=0;

	if ( !*m )  return( atol( t ) );

	for ( ; *m!='_'; m++ );
	for ( ; *t; m++, i++ )
		{
			if ( *m=='_' )
			  {
				if ( *t!=' ' )
					str[i]= *t;
				else if ( !j )
					{ for ( j=i; j>0; j-- ) str[j]=str[j-1]; str[j]='0'; }
				else
					str[i]='0';
				t++;
			  }
			else
				j=(int)(str[i]=*m);
		}
	str[i]='\0';
	return( atol( str ) );
}

void obj_sval( OBJECT *o, long val )
{ char  *t;
  int d;
  char s[10];

	t = o->ob_type==G_STRING ? o->ob_spec.free_string \
							 : o->ob_spec.tedinfo->te_ptext;
	d=(int)strlen( t );
	ltoa( val, s, 10);
	strncpy( t, "          ", d ); 
	d -=(int) strlen(s); strcpy( t+d, s);	
}

int obj_do( OBJECT *t, int start_o )
{  int x,y,w,h,ret;
   int xy[8];
   char *buf_blt;
   MFDB p0={ 0L, },p={ 0L,0,0,0,0,1,0,0,0 };

	x= t->ob_x; y= t->ob_y; w= t->ob_width; h= t->ob_height;

	if ( (buf_blt=(char*)malloc( h * 80 + 164 )) != NULL )
		{
			p.fd_w= w+4; p.fd_h= h+2;
			p.fd_addr= buf_blt; p.fd_wdwidth= p.fd_w/16+((p.fd_w&0x0f)!=0);
			xy[0]=x; xy[1]=y;
			xy[2]= xy[0]+(xy[6]=w+4); xy[3]= xy[1]+(xy[7]=h+2);
			xy[4]= xy[5]= 0;
			v_hide_c( handle );			/* Kurzor vypn ## */
			vro_cpyfm( handle, S_ONLY, xy, &p0, &p );
			v_show_c( handle, 1 );		/* Zapn kurzor */
		}
	form_dial(0,0,0,0,0,x,y,w,h);
	form_dial(1,0,0,0,0,x,y,w,h);
	objc_draw( t, 0, 7, x, y, w, h );
	ret = form_do( t, start_o );
	menu_tnormal( t, ret, 1 );
	form_dial(2,0,0,0,0,x,y,w,h);
	form_dial(3,0,0,0,0,x,y,w,h);
	if ( buf_blt )
		{
			xy[6]= (xy[4]=x) + (xy[2]=w+4);
			xy[7]= (xy[5]=y) + (xy[3]=h+2);
			xy[0]= xy[1]= 0;
			v_hide_c( handle );			/* Kurzor vypn ## */
			vro_cpyfm( handle, S_ONLY, xy, &p, &p0 );
			v_show_c( handle, 1 );		/* Zapn kurzor */
			free( buf_blt );
		}
	return( ret );
}

void obj_select( OBJECT *o , int s )
{
	if ( s )
		o->ob_state&=~DISABLED;
	else
		o->ob_state|=DISABLED;
}

int inic( char *fn )
{ int ret=0;
  int x,y,w,h;

  if ( (ret=rsrc_load( fn ))>0 )
  {
	rsrc_gaddr( 0, T_MAIN, &t_main ); form_center( t_main,&x,&y,&w,&h );
	rsrc_gaddr( 0, T_FORMAT, &t_format ); form_center( t_format,&x,&y,&w,&h );
	rsrc_gaddr( 0, T_IF_FRM, &t_if_frm ); form_center( t_if_frm,&x,&y,&w,&h );
	rsrc_gaddr( 0, T_IINDSK, &t_iindsk ); form_center( t_iindsk,&x,&y,&w,&h );
	rsrc_gaddr( 0, T_SELDX, &t_seldx ); form_center( t_seldx,&x,&y,&w,&h );
	rsrc_gaddr( 0, T_CHNAM, &t_chnam ); form_center( t_chnam,&x,&y,&w,&h );
	rsrc_gaddr( 0, T_ERROR, &t_error ); form_center( t_error,&x,&y,&w,&h );
	mx= t_main->ob_x; my= t_main->ob_y;
	mw= t_main->ob_width; mh= t_main->ob_height;
	tab_dx[0]=3; tab_dx[1]=1; tab_dx[2]=2;
	if ( (bufer=malloc(MAX_BUF)) > NULL && (tr_3buf=malloc(MAX_TRACK)) > NULL && (ramdisk=malloc(MAX_RAM)) > NULL )
		{	tr_3p=-1;		/* no track in bufer */
			rd_free=MAX_RAM; diskr[3]=256; diskr[2]=18; diskr[0]=1;
			diskr[1]=(int)(MAX_RAM/(256*18*2));
			ret=1;
		}
	else
		form_alert( 1, "[3][ memory out ! ][ ABORT ]" );
  }
  else
	form_alert( 1, "[3][ can't find RSC file ][ ABORT ]" );
  return( ret );
}
/*---------specialne funkcie---------*/

#define WAIT		for(tim=8L;--tim;)

#pragma warn -par
long read_track_s( int empty, int disk, int track )
{  register int *afdc=(int*)0xff8604L;
   register int *actr=(int*)0xff8606L;
   register unsigned long tim,pom;
/*   int status;	*/

/*	move_to_sr( ( status=move_sr() ) | 0x700 );	*/
	*actr=0x80; WAIT ; *afdc=0x00; WAIT;	/* restore */
	for (tim=0x60000L; (*afdc & 4)==0 && --tim; );
	if ( (*afdc & 4)!=0 )
		{	*actr=0x86; WAIT; *afdc=track; WAIT; disk_track[disk]=track;
			*actr=0x80; WAIT; *afdc=16; WAIT;	/* seek */
			for (tim=0x60000L;(*afdc & 1)!=0 && --tim>0; );
			if ( (*afdc & 1)==0 )
				{	/*	*actr=0x82; *afdc=track;	*/
					pom= (unsigned long) bufer;
					*((char*)0xff8609L)=(char)(pom >>16);
					*((char*)0xff860bL)=(char)(pom >>8);
					*((char*)0xff860dL)=(char) pom;
					*actr=0x90; *actr=0x190; *actr=0x90; WAIT ; *afdc=20; WAIT;
					*actr=0x80; WAIT; *afdc=224; WAIT;
					for ( tim=0x30000L, pom=*((char*)0xff860dL);
							--tim && *((char*)0xff860dL) == pom; );
					if (tim)
						do	{	pom=*((char*)0xff860dL);
								for(tim=220L;--tim;);
							}
						while ( *((char*)0xff860dL) != pom );
					*actr=0x80; WAIT; *afdc=208; WAIT;	/* force interupt */
/*					for (tim=0x40000L;--tim;);	*/
					while( *afdc & 1 );
					if ( (*afdc & 0x01)==0 )
						{
							pom=*((byte*)0xff8609L); pom<<=16;
							pom |=(*((byte*)0xff860bL)<<8) & 0x0ffffL;
							pom |=*((byte*)0xff860dL);
/*							move_to_sr( status );	*/
							return( (char*)pom - bufer );
						}
				}
		}
/*	move_to_sr( status );	*/
	return (-1);
}
long read_track_p( int empty, int disk, int track )
{	return ( Supexec( read_track_s ) );
}
#pragma warn +par

long read_track( int disk, int side, int track )
{  long ret;
	Offgibit( 0xfe -2*(disk==0) -4*(disk==1) );
	Ongibit( (side==0) + 4*(disk==0) + 2*(disk==1) );
	ret=read_track_p( 0, disk, track );
/*	Ongibit( 6 );	* Vyp. chip select */
	return( ret );
}

#pragma warn -par
long write_track_s( int empty, int disk, int track )
{  register int *afdc=(int*)0xff8604L;
   register int *actr=(int*)0xff8606L;
   register unsigned long tim,pom;
/*   int status;	*/

/*	move_to_sr( ( status=move_sr() ) | 0x700 );	*/
	*actr=0x82; WAIT; *afdc=disk_track[disk]; WAIT;
	*actr=0x86; WAIT; *afdc=track; WAIT; disk_track[disk]=track;
	*actr=0x80; WAIT; *afdc=16; WAIT;	/* seek */
	for (tim=0x60000L;(*afdc & 1)!=0 && --tim>0; );
	if ( (*afdc & 1)==0 )
		{	/*	*actr=0x82; *afdc=track;	*/
			pom= (unsigned long) bufer;
			*((char*)0xff8609L)=(char)(pom >>16);
			*((char*)0xff860bL)=(char)(pom >>8);
			*((char*)0xff860dL)=(char) pom;
			*actr=0x190; *actr=0x90; *actr=0x190; WAIT ; *afdc=20; WAIT;
			*actr=0x180; WAIT; *afdc=240; WAIT;
			for ( tim=0x30000L, pom=*((char*)0xff860dL);
					--tim && *((char*)0xff860dL) == pom; );
			if (tim)
				do	{	pom=*((char*)0xff860dL);
						for(tim=220L;--tim;);
					}
				while ( *((char*)0xff860dL) != pom );
			*actr=0x80; WAIT; *afdc=208; WAIT;	/* force interupt */
/*			for (tim=0x40000L;--tim;);	*/
			while( *afdc & 1 );
			if ( (*afdc & 0x01)==0 )
				{
					pom=*((byte*)0xff8609L); pom<<=16;
					pom |=(*((byte*)0xff860bL)<<8) & 0x0ffffL;
					pom |=*((byte*)0xff860dL);
/*					move_to_sr( status );	*/
					return( (char*)pom - bufer );
				}
		}
/*	move_to_sr( status );	*/
	return (-1);
}
long write_track_p( int empty, int disk, int track )
{	return ( Supexec( write_track_s ) );
}
#pragma warn +par

long write_track( int disk, int side, int track )
{  long ret;
	Offgibit( 0xfe -2*(disk==0) -4*(disk==1) );
	Ongibit( (side==0) + 4*(disk==0) + 2*(disk==1) );
	ret=write_track_p( 0, disk, track );
/*	Ongibit( 6 );	* Vyp. chip select */
	return( ret );
}


#pragma warn -par
long read_sector_s( int empty, int disk )
{  register int *afdc=(int*)0xff8604L;
   register int *actr=(int*)0xff8606L;
   register unsigned long tim,pom;
   int stat_pom;
   byte status;
   int psw;

	move_to_sr( ( psw=move_sr() ) | 0x700 );

	*actr=0x82; WAIT; *afdc=disk_track[disk]; WAIT;	/* last track */
	if (disk_track[disk] != gl_doc.track)
		{	*actr=0x86; WAIT; *afdc=gl_doc.track; WAIT;
			*actr=0x80; WAIT; *afdc=24; WAIT;	/* seek */
			for (tim=0x50000L;(*afdc & 1)!=0 && --tim>0; );
		}
	*actr=0x80; WAIT;
		if ( (*afdc & 1)==0 )
			{	disk_track[disk]=gl_doc.track;
				pom= (unsigned long) bufer;
				*((char*)0xff8609L)=(char)(pom >>16);
				*((char*)0xff860bL)=(char)(pom >>8);
				*((char*)0xff860dL)=(char) pom;
				*actr=0x90; *actr=0x190; *actr=0x90;
				WAIT ; *afdc=gl_doc.count; WAIT;
				*actr=0x84; *afdc=gl_doc.sector;
				if (gl_doc.count==1)
					{ *actr=0x80; WAIT; *afdc=136; WAIT; }
				else
					{ *actr=0x80; WAIT; *afdc=152; WAIT; }
				for ( tim=0x30000L, pom=*((char*)0xff860dL);
						--tim && *((char*)0xff860dL) == pom; );
				if (tim)
					do	{	pom=*((char*)0xff860dL);
							for(tim=220L;--tim;);
						}
					while ( *((char*)0xff860dL) != pom );
				stat_pom=*afdc; WAIT; gl_pom=status=(byte)stat_pom;
				*actr=0x80; WAIT; *afdc=208; WAIT;	/* force interupt */
				while( *afdc & 1 );
				if ( (status & 0x18)==0 )
					{
						pom=*((byte*)0xff8609L); pom<<=16;
						pom |=(*((byte*)0xff860bL)<<8) & 0x0ffffL;
						pom |=*((byte*)0xff860dL);
						move_to_sr( psw );
						if ( ((char*)pom-bufer)>63 )
							  return( (char*)pom - bufer );
						else  return(-(long)status);
					}
				else	
					{	move_to_sr( psw );
						return(-(long)status);
					}
			}
	move_to_sr( psw );
	return (-1);
}
#pragma warn +par

long read_sector( int disk, int side, int track, int sec, int count)
{
	Offgibit( 0xfe -((disk==0)<<1) -((disk==1)<<2) );
	Ongibit( (side==0) + ((disk==0)<<2) + ((disk==1)<<1) );
	gl_doc.track=track; gl_doc.sector=sec; gl_doc.count=count;
	return( super_exec( read_sector_s, (long)disk ) );	/* read_sector_p( 0, disk ); */
/*	Ongibit( 6 );	* Vyp. chip select *
	return( ret );
*/
}

#pragma warn -par
long write_sector_s( int empty, int disk )
{  register int *afdc=(int*)0xff8604L;
   register int *actr=(int*)0xff8606L;
   register unsigned long tim,pom;
   int stat_pom;
   byte status;
   int psw;

	move_to_sr( ( psw=move_sr() ) | 0x700 );

	*actr=0x82; WAIT; *afdc=disk_track[disk]; WAIT;	/* last track */
	*actr=0x86; WAIT; *afdc=gl_doc.track; WAIT;
	*actr=0x80; WAIT; *afdc=24; WAIT;	/* seek */
	for (tim=0x50000L;(*afdc & 1)!=0 && --tim>0; );
		if ( (*afdc & 1)==0 )
			{	disk_track[disk]=gl_doc.track;
				pom= (unsigned long) bufer;
				*((char*)0xff8609L)=(char)(pom >>16);
				*((char*)0xff860bL)=(char)(pom >>8);
				*((char*)0xff860dL)=(char) pom;
				*actr=0x190; *actr=0x90; *actr=0x190;
				WAIT ; *afdc=gl_doc.count; WAIT;
				*actr=0x184; *afdc=gl_doc.sector;
				if (gl_doc.count==1)
					{ *actr=0x180; WAIT; *afdc=168; WAIT; }
				else
					{ *actr=0x180; WAIT; *afdc=184; WAIT; }
				for ( tim=0x30000L, pom=*((char*)0xff860dL);
						--tim && *((char*)0xff860dL) == pom; );
				if (tim)
					do	{	pom=*((char*)0xff860dL);
							for(tim=220L;--tim;);
						}
					while ( *((char*)0xff860dL) != pom );
				stat_pom=*afdc; WAIT; gl_pom=status=(byte)stat_pom;
				*actr=0x80; WAIT; *afdc=208; WAIT;	/* force interupt */
				while( *afdc & 1 );
				if ( (status & 0x18)==0 )
					{
						pom=*((byte*)0xff8609L); pom<<=16;
						pom |=(*((byte*)0xff860bL)<<8) & 0x0ffffL;
						pom |=*((byte*)0xff860dL);
						move_to_sr( psw );
						if ( ((char*)pom-bufer)>63 )
							  return( (char*)pom - bufer );
						else  return(-(long)status);
					}
				else
					{	move_to_sr( psw );
						return(-(long)status);
					}
			}
	move_to_sr( psw );
	return (-1);
}
#undef WAIT
#pragma warn +par

long write_sector( int disk, int side, int track, int sec, int count)
{
	Offgibit( 0xfe -((disk==0)<<1) -((disk==1)<<2) );
	Ongibit( (side==0) + ((disk==0)<<2) + ((disk==1)<<1) );
	gl_doc.track=track; gl_doc.sector=sec; gl_doc.count=count;
	return( super_exec( write_sector_s, (long)disk ) );	/* read_sector_p( 0, disk ); */
/*	Ongibit( 6 );	* Vyp. chip select *
	return( ret );
*/
}

long unselect_B_s( void )
{
	*(int*)0xff8606L=0x80;	
	return ( *(int*)0xff8604L );
}

void unselect_B( void )
{
	if ( !((int)TRAP_0( F_SUPEXEC, 0L, unselect_B_s ) & 0x080) )
		{ select_B=0; Ongibit( 6 ); }		/* Vyp. chip select */
}

/*--------interne funkcie------------*/

void disable_3( int x )
{
	switch( x )
		{	case 8:	objc_change(t_main,O_3_D8,0,mx,my,mw,mh,NORMAL,1);
			case 7:	objc_change(t_main,O_3_D7,0,mx,my,mw,mh,NORMAL,1);
			case 6:	objc_change(t_main,O_3_D6,0,mx,my,mw,mh,NORMAL,1);
			case 5:	objc_change(t_main,O_3_D5,0,mx,my,mw,mh,NORMAL,1);
			case 4:	objc_change(t_main,O_3_D4,0,mx,my,mw,mh,NORMAL,1);
			case 3:	objc_change(t_main,O_3_D3,0,mx,my,mw,mh,NORMAL,1);
			case 2:	objc_change(t_main,O_3_D2,0,mx,my,mw,mh,NORMAL,1);
			case 1:	objc_change(t_main,O_3_D1,0,mx,my,mw,mh,NORMAL,1);
		}
	switch( x )
		{	case 0:	objc_change(t_main,O_3_D1,0,mx,my,mw,mh,DISABLED,1);
			case 1:	objc_change(t_main,O_3_D2,0,mx,my,mw,mh,DISABLED,1);
			case 2:	objc_change(t_main,O_3_D3,0,mx,my,mw,mh,DISABLED,1);
			case 3:	objc_change(t_main,O_3_D4,0,mx,my,mw,mh,DISABLED,1);
			case 4:	objc_change(t_main,O_3_D5,0,mx,my,mw,mh,DISABLED,1);
			case 5:	objc_change(t_main,O_3_D6,0,mx,my,mw,mh,DISABLED,1);
			case 6:	objc_change(t_main,O_3_D7,0,mx,my,mw,mh,DISABLED,1);
			case 7:	objc_change(t_main,O_3_D8,0,mx,my,mw,mh,DISABLED,1);
		}
}

void enable_5( void )
{
	objc_change(t_main,O_5_S1,0,mx,my,mw,mh,NORMAL,1);
}

void disable_5( void )
{
	objc_change(t_main,O_5_S1,0,mx,my,mw,mh,DISABLED,1);
}

void error(char *t)
{
	menu_text( t_error, O_ERRTXT, t);
	obj_do( t_error, -1);
}

void dx_select(int x,OBJECT *p, int bt)
{ OBJECT *o=p+bt;
  char *t;
	switch ( obj_do( t_seldx, -1) )
		{	case O_SDX1: tab_dx[x]=1; break;
			case O_SDX2: tab_dx[x]=2; break;
			case O_SDX3: tab_dx[x]=3; break;
			case O_SDX4: tab_dx[x]=4; break;
			case O_SDX5: tab_dx[x]=5; break;
			case O_SDX6: tab_dx[x]=6; break;
			case O_SDX7: tab_dx[x]=7; break;
			case O_SDX8: tab_dx[x]=8; break;
		}
	t = o->ob_spec.free_string;
	t[1]='0'+tab_dx[x];
	menu_tnormal( p, bt, 1 );
	objc_draw( t_main, bt, 1, mx, my, mw, mh);
}

void dsk_protect(int x,OBJECT *p, int bt )
{	write_protect[x]= p[bt].ob_state & SELECTED ?1:0;
}

void dsk_speed(int x,OBJECT *p, int bt )
{	speedy[x]= p[bt].ob_state & SELECTED ?1:0;
}

void select3(int x)
{
	tr_3p=-1;		/* no track in bufer */
	if (x <= disk3[0][2] && x > 0)
		{	cd3=x;
			vypis3();
		}
}

void select5(int x)
{
	if (x==1 || x==2 && disk5[0][0]==0)
		{	cs5=x-1;
			vypis5();
		}
}

void read3( void )
{ int i,j;

	tr_3p=-1;		/* no track in bufer */
	if ( Floprd(bufer,0L,0,DISK3_INFO,0,0,1)==0 )
		{	for (i=0;i<9;i++)
				{	for (j=0;j<8;j++)
						{	disk3[i][j]=bufer[i*8+j];
							if (j==3 || j==7)
								disk3[i][j]=RES_BPS( bufer[i*8+j] );
						}
					for (j=0;j<16;j++)
						{	disk3_name[i][j]=bufer[ZAC_NAM+i*16+j];
							disk3_name[i][16]=0;
						}
				}
			cd3=1;
			disable_3( disk3[0][2] );
			form_button( t_main, O_3_D1, 1, &i );
			select3( 1 );
			vypis3();
		}
	else
		{	cd3= disk3[0][2]= 0;
			disable_3( 0 );
			error("Can't read disk information!");
		}
}

void read5( void )
{  int j,sec1,sec2,sd2,bps1,bps2; /*sd1*/
   long dl,i;
	form_button( t_main, O_5_S0, 1, &j );

	sec1=sec2=0; sd2=0; bps1=bps2=0;
	if ( (dl=read_track( 1, 0, 0 )) > 0 )
		for (i=0;i<dl;i++)
			if (bufer[i]==161 && bufer[i+1]==161 && bufer[i+2]==254 )
				{	/*sd1=bufer[i+4];*/  bps1=bufer[i+6]; sec1++;	}
			else	if (bufer[i]==161 && bufer[i+1]==161 && bufer[i+2]==0xfb )
						i+=3+RES_BPS( bps1 );
	if ( (dl=read_track( 1, 1, 0 )) > 0 )
		for (i=0;i<dl;i++)
			if (bufer[i]==161 && bufer[i+1]==161 && bufer[i+2]==254 )
				{	sd2=bufer[i+4]; bps2=bufer[i+6]; sec2++;	}
			else	if (bufer[i]==161 && bufer[i+1]==161 && bufer[i+2]==0xfb )
						i+=3+RES_BPS( bps2 );
	disk5[0][2]=sec1; disk5[1][2]=sec2;
	disk5[0][3]=RES_BPS( bps1 ); disk5[1][3]=RES_BPS( bps2 );
	disk5[0][0]=0; disk5[1][0]=0;
	if ( sec2>0 && sd2==1 ) { disk5[0][0]=1; disable_5(); }
	else	enable_5();
	disk5[0][1]=40; disk5[1][1]=40;
	cs5=0;
	vypis5();
	select_B=1; delay_sel=DELAY_SEL;
}

void vypis3( void )
{
	obj_sval( t_main+ O_3_SDS, disk3[cd3][4] );
	obj_sval( t_main+ O_3_TRK, disk3[cd3][5] );
	obj_sval( t_main+ O_3_SCS, disk3[cd3][6] );
	obj_sval( t_main+ O_3_BPS, disk3[cd3][7] );
	menu_text(t_main, O_3_NAME, disk3_name[cd3] );
	objc_draw( t_main, O_3_NAMP, 2, mx, my, mw, mh );
	objc_draw( t_main, O_3_PODL, 2, mx, my, mw, mh );
}

void vypis5( void )
{
	disk5_max=disk5[cs5][2] * disk5[cs5][1] * (1+disk5[cs5][0]);
	obj_sval( t_main+ O_5_SDS, disk5[cs5][0] );
	obj_sval( t_main+ O_5_TRK, disk5[cs5][1] );
	obj_sval( t_main+ O_5_SCS, disk5[cs5][2] );
	obj_sval( t_main+ O_5_BPS, disk5[cs5][3] );
	objc_draw( t_main, O_5_PODL, 2, mx, my, mw, mh );
}

void vypisr( void )
{
	obj_sval( t_main+ O_R_FRE, rd_free );
	obj_sval( t_main+ O_R_SDS, diskr[0] );
	obj_sval( t_main+ O_R_TRK, diskr[1] );
	obj_sval( t_main+ O_R_SCS, diskr[2] );
	obj_sval( t_main+ O_R_BPS, diskr[3] );
	objc_draw( t_main, O_R_FREP, 2, mx, my, mw, mh );
	objc_draw( t_main, O_R_PODL, 2, mx, my, mw, mh );
}

void format3( void )
{
	ikbd_off;
/*	sio_send( &sio_s ); */
	sio_receive( &povel_sio );
	printf( "\033H err HEAD: %3d  %3d  %3d  %3d  %3d = %3d : %d  ",
		povel_buf[0],povel_buf[1],povel_buf[2],povel_buf[3],povel_buf[4],povel_buf[5],check_sum(povel_buf,4) );
	objc_change(t_main,O_3_FORM,0,mx,my,mw,mh,0,1);
	ikbd_on;
}

void name3( void )
{ OBJECT *o=t_chnam+O_CHN_NM;
  TEDINFO *ted = o->ob_spec.tedinfo;
  char  *t=ted->te_ptext;
  int i;

	objc_change(t_main,O_3_NAME,0,mx,my,mw,mh,0,1);
	strcpy( t, disk3_name[cd3] );
	if ( cd3>0 && obj_do(t_chnam, O_CHN_NM) == O_CHN_OK )
		{
			strcpy(disk3_name[cd3], t);
			if ( Floprd(bufer,0L,0,DISK3_INFO,0,0,1)==0 )
				{
					for (i=0;i<16 && (bufer[ZAC_NAM+cd3*16+i]=t[i])!=0;i++);
					while (i<16) bufer[ZAC_NAM+cd3*16+(i++)]=0;
					if ( Flopwr(bufer,0L,0,DISK3_INFO,0,0,1)<0 )
						error("Can not WRITE sektor info!");
				}
			else	error("Can not READ sektor info!");
		}
}

int do_main( int obj )
{ /* OBJECT *t=t_main+obj; */
	switch ( obj )
			{   case O_3_D1: select3(1); break;
				case O_3_D2: select3(2); break;
				case O_3_D3: select3(3); break;
				case O_3_D4: select3(4); break;
				case O_3_D5: select3(5); break;
				case O_3_D6: select3(6); break;
				case O_3_D7: select3(7); break;
				case O_3_D8: select3(8); break;
				case O_5_S0: select5(1); break;
				case O_5_S1: select5(2); break;
				case O_3_READ:	read3(); objc_change(t_main,obj,0,mx,my,mw,mh,0,1);
								break;
				case O_5_READ:	read5(); objc_change(t_main,obj,0,mx,my,mw,mh,0,1);
								break;
				case O_3_FORM: format3(); break;
				case O_3_NAME: name3();	break;
				case O_3_DX: dx_select(1, t_main,O_3_DX ); break;
				case O_5_DX: dx_select(2, t_main,O_5_DX ); break;
				case O_R_DX: dx_select(0, t_main,O_R_DX ); break;
				case O_3_PROT:	dsk_protect(1, t_main,O_3_PROT ); break;
				case O_5_PROT:	dsk_protect(2, t_main,O_5_PROT ); break;
				case O_R_PROT:	dsk_protect(0, t_main,O_R_PROT ); break;
				case O_3_SPED:	dsk_speed(1, t_main,O_3_SPED ); break;
				case O_5_SPED:	dsk_speed(2, t_main,O_5_SPED ); break;
				case O_EXIT: return (1);
			}
	return (0);
}
/*---------------- XF551 ---------------*/
byte check_sum( byte *buf, int dl)
{ register int sum=0;
  register byte *end=buf+dl;

  	while ( buf < end )
  		{	sum += *buf++;
  			if ( sum >= 256 ) sum= (sum+1)&0xff;
  		}
  	return ( (byte)sum );
}

void set_sio( int x )
{
	sio_r.buf=bufer; sio_s.buf=bufer;
	sio_r.timeout=TIMEOUT; sio_s.timeout=TIMEOUT;
	sio_r.bit=0x80; sio_s.bit=0x100;
	if (!x)
		{	sio_r.wait1=WAIT1_19; sio_r.wait2=WAIT2_19;
			sio_r.waitp=WAITP_19; sio_s.wait1=WAIT_19;
			sio_s.waitp=WAITS_19;
		}
	else
		{	sio_r.wait1=WAIT1_38; sio_r.wait2=WAIT2_38;
			sio_r.waitp=WAITP_38; sio_s.wait1=WAIT_38;
			sio_s.waitp=WAITS_38;
		}
}

void pause( void )
{  int i;
	for (i=0x7000;i>0;i--);
}

/*---------- RAM DISK --------------*/
void ini_prdisk( void )
{
	prdisk[0]=diskr[0];
	prdisk[1]=diskr[1];
	prdisk[2]=diskr[2];
	prdisk[3]=diskr[3];
}

void ram_read( int sec )
{  long ramadr;
   int i;
   byte pom;
	sio_send( &sio_odpov );
	if ( sec<=diskr[2] * diskr[1] * (1+diskr[0]) && sec >0 )
		{	ramadr=MULu( (sec-1), diskr[3] );
			memcpy( bufer, &ramdisk[ramadr], (i=diskr[3]) );
			pom=bufer[0]; bufer[0]=DATA_OK; sio_send( &sio_s ); bufer[0]=pom;
			if (sec<=3) i=128;
			bufer[i]=check_sum(bufer,i);
			sio_s.size=i+1; sio_send( &sio_s );
			ram_stat=0;
		}
	else
		{	pause(); bufer[0]=NO_CMD; sio_send( &sio_s ); ram_stat=16;
		}
}

void ram_write( int sec )
{  long ramadr;
   int j;
	sio_send( &sio_odpov );
	j=diskr[3]; if (sec<=3) j=128;
	sio_r.size=j+1;
	if ( sio_receive( &sio_r )==0 && bufer[j]==check_sum(bufer,j) )
	  {	if ( sec <= diskr[2] * diskr[1] * (1+diskr[0]) && sec >0 && write_protect[0]==0 )
			{	ramadr=MULu( (sec-1), diskr[3]);
/*				if (sec<=3) for(i=0;i<128;i++) bufer[i+128]=bufer[i]; */
				memcpy( &ramdisk[ramadr], bufer, diskr[3] );
				sio_s.size=1; bufer[0]=DATA_OK; sio_send( &sio_s );  sio_send( &sio_s );
				ram_stat=0;
			}
		else	{	sio_s.size=1; bufer[0]=DATA_OK; sio_send( &sio_s ); 
					pause(); bufer[0]=NO_CMD; sio_send( &sio_s ); ram_stat=16;
				}
	  }
	else	{	sio_s.size=1; bufer[0]=DATA_ERR; sio_send( &sio_s ); ram_stat=16;	}
}

void ram_status( void )
{  int i;
	sio_send( &sio_odpov );
	for (i=0;i<64;i++);
	bufer[0]=DATA_OK; sio_send( &sio_s );
	bufer[1]=128 | (~ram_stat); bufer[2]=254; bufer[3]=0;
	if (diskr[3]==256) bufer[0]=32+(96-32)*diskr[0];
	else	bufer[0]=(diskr[2]==26)?128:0;
	bufer[4]=check_sum(bufer,4);
	sio_s.size=5; sio_send( &sio_s );
}

void ram_infin( void )
{
	sio_send( &sio_odpov );
	sio_r.size=13;
	if ( sio_receive( &sio_r )==0 && bufer[12]==check_sum(bufer,12) )
		{	if ( MULu(bufer[0]*bufer[3]*(1+bufer[4]),(bufer[7]+(bufer[6]<<8)))
					 <= rd_free )
				{	prdisk[0]=bufer[4]; prdisk[1]=bufer[0];
					prdisk[2]=bufer[3]; prdisk[3]=bufer[7]+(bufer[6]<<8);
				}
			else ini_prdisk();
			bufer[0]=DATA_OK; sio_send( &sio_s );  sio_send( &sio_s );
		}
	else	{ bufer[0]=DATA_ERR; sio_send( &sio_s );	}
}

void ram_infout( void )
{
	sio_send( &sio_odpov );
	bufer[1]=0; bufer[2]=0; bufer[3]=prdisk[2]; bufer[4]=prdisk[0];
	bufer[5]=(prdisk[2]==18 && prdisk[3]==128)?0:4;
	bufer[6]=prdisk[3]>>8; bufer[7]=( prdisk[3] & 255 );
	bufer[8]=1; bufer[9]=65; bufer[10]=0; bufer[11]=0;
	bufer[0]=DATA_OK; sio_send( &sio_s );
	bufer[0]=prdisk[1];
	bufer[12]=check_sum( bufer, 12 );
	sio_s.size=13; sio_send( &sio_s );
}

void ram_format( void )
{  unsigned int j;
	if (write_protect[0]==0)
		{	sio_send( &sio_odpov );
			memset( ramdisk, 0, rd_free );
			for (j=0;j<0xF000U;j++);	/* wait */
			for (j=0;j<4;j++)	diskr[j]=prdisk[j];
			for (j=0;j<diskr[3];j++)	bufer[j]=0;
			bufer[0]=DATA_OK; sio_send( &sio_s );
			for (j=0;j<4;j++)	bufer[j]=255;
			bufer[diskr[3]]=check_sum(bufer,diskr[3]);
			sio_s.size=diskr[3]+1; sio_send( &sio_s );
			vypisr();
		}
	else
		{	odpoved=NO_CMD; sio_send( &sio_odpov ); odpoved=CMD_OK;
		}
}

void ram_main( byte cmd, byte aux1, byte aux2 )
{  int sec;
	sec=aux1+(aux2<<8);
	set_sio( cmd & 0x80 );
	sio_s.size=1;
	switch (cmd & 0x7f)
		{	case 82: ini_prdisk(); ram_read(sec); break;
			case 87: ini_prdisk(); ram_write(sec); break;
			case 80: ini_prdisk(); ram_write(sec); break;
			case 83: ram_status(); break;
			case 78: ini_prdisk(); ram_infout(); break;
			case 79: ram_infin(); break;
			case 33: ram_format(); break;
			case 34: 	prdisk[0]=0;prdisk[1]=40;prdisk[2]=26;prdisk[3]=128;
						ram_format(); break;
			default: odpoved=NO_CMD; sio_send( &sio_odpov ); odpoved=CMD_OK;
		}
	povel=0;
}

/*---------- DISK 3 1/2 --------------*/
void ini_p3disk( void )
{
	p3disk[0]=disk3[cd3][4];
	p3disk[1]=disk3[cd3][5];
	p3disk[2]=disk3[cd3][6];
	p3disk[3]=disk3[cd3][7];
}

int disk3_rewr( void )
{  int pos,trk,sde,poc;
   byte local_buf[512];

	disk3_wrtrack=0;
	poc=2;
	pos=(disk3_minsek-1)*disk3[cd3][3];
	memcpy( local_buf, bufer, 512 );
	memcpy( bufer, &tr_3buf[pos], disk3[cd3][3]*(disk3_maxsek-disk3_minsek+1) );
	trk=tr_3p & 0xff; sde=(tr_3p>>8);
disk3_rewr_retry:
	if ( Flopwr( bufer, 0L, 0, disk3_minsek, trk, sde, disk3_maxsek-disk3_minsek+1)<0 )
		goto disk3_rewr_error;
	disk3_stat=0;
	memcpy( bufer, local_buf, 512 );
	return(0);
disk3_rewr_error:
	if (--poc) goto disk3_rewr_retry;
	error("Can't write track!!!");
	memcpy( bufer, local_buf, 512 );
	return (-1);
}

void disk3_read( int sec )
{  unsigned int i,sde,trk,pos,sf;
   byte pom;
	sio_send( &sio_odpov );
	if ( sec<=disk3[cd3][6] * disk3[cd3][5] * (1+disk3[cd3][4]) && sec >0 && cd3 >0 )
		{	sf=DIVu( MULu((sec-1),disk3[cd3][7]), disk3[cd3][3] );
			trk=( disk3[cd3][0]+DIVu( (unsigned long)sf, disk3[cd3][2] ) ) % disk3[0][1];
			sde=DIVu( ( disk3[cd3][0]+DIVu( (unsigned long)sf, disk3[cd3][2] ) ), disk3[0][1]);
			pos=(unsigned)MULu((sec-1),disk3[cd3][7]) % disk3[cd3][3];
			pos+=(sf % disk3[cd3][2])*disk3[cd3][3];
			if ( tr_3p!=( trk+(sde<<8) ) )
				{	if (disk3_wrtrack)	disk3_rewr();
					if ( Floprd( tr_3buf, 0L, 0, 1, trk, sde, disk3[cd3][2])==0 )
						tr_3p= trk+(sde<<8);
					else { tr_3p=-1; goto d3_read_error; }
				}
			memcpy( bufer, &tr_3buf[pos], (i=disk3[cd3][7]) );
			pom=bufer[0]; bufer[0]=DATA_OK; sio_send( &sio_s ); bufer[0]=pom;
			if (sec<=3) i=128;
			disk3_stat=0;
			bufer[i]=check_sum(bufer,i);
			sio_s.size=i+1; sio_send( &sio_s );
		}
	else
		{	pause(); bufer[0]=NO_CMD; sio_send( &sio_s ); disk3_stat=16;
		}
	return;
d3_read_error:
		{	bufer[0]=DATA_ERR; sio_send( &sio_s ); disk3_stat=16;
		}
}

void disk3_write( int sec, int x )
{  int i,j,sde,trk,sek,pos,sf;
   unsigned long pom;

	sio_send( &sio_odpov );
	j=disk3[cd3][7]; if (sec<=3) j=128;
	sio_r.size=j+1;
	if ( sio_receive( &sio_r )==0 && bufer[j]==check_sum(bufer,j) && write_protect[1]==0 )
	  {	sio_s.size=1;
	    sf=bufer[0]; bufer[0]=DATA_OK; sio_send( &sio_s ); bufer[0]=sf;
		pom= MULu((sec-1),disk3[cd3][7]);
	  	sf=(int)(pom= DIV_MOD( pom, disk3[cd3][3] ));
		pos=(int)SWAP( pom );
		sek= (sf % disk3[cd3][2]);
		pos+= sek*disk3[cd3][3];
		pom= DIVu( (unsigned long)sf, disk3[cd3][2] );
		sde=(int)(pom= DIV_MOD( ( disk3[cd3][0]+pom ), disk3[0][1]));
		trk= (int)SWAP( pom );
	  	if ( sec<=disk3[cd3][6] * disk3[cd3][5] * (1+disk3[cd3][4]) && sec >0 )
	  		{	if (tr_3p!=( trk+(sde<<8) ) )
					{	if ( disk3_wrtrack )	disk3_rewr();
						if ( Floprd( tr_3buf, 0L, 0, 1, trk, sde, disk3[cd3][2])==0 )
							tr_3p= trk+(sde<<8);
						else { tr_3p=-1; goto d3_write_error; }
					}
				if (sec<=3) for(i=0;i<128;i++) bufer[i+128]=bufer[i];
				memcpy( &tr_3buf[pos], bufer, disk3[cd3][7] );
				pos=sek*disk3[cd3][3];
				if ( speedy[1] )
					{	if (disk3_wrtrack!=0)
							{ disk3_minsek=min(disk3_minsek,sek+1);
							  disk3_maxsek=max(disk3_maxsek,sek+1);
							}
						else { disk3_minsek=sek+1; disk3_maxsek=sek+1; }
						disk3_wrtrack=1; 
						goto d3_write_obskok;
					}
				memcpy( bufer, &tr_3buf[pos], disk3[cd3][3] );
		  		if ( Flopwr( bufer, 0L, 0, sek+1, trk, sde, 1)<0 )
		  			{ tr_3p=-1; disk3_stat=64; goto d3_write_error; }
				disk3_stat=0;
				if (x==0)	/* 0-WRITE / PUT */
					{	if ( Floprd( bufer, 0L, 0, sek+1, trk, sde, 1)==0 )
							{ bufer[0]=DATA_OK; sio_send( &sio_s ); }
						else {	bufer[0]=DATA_ERR; sio_send( &sio_s );	}
					}
				else
d3_write_obskok:
					{ bufer[0]=DATA_OK; sio_send( &sio_s ); }
			}
		else	{ pause(); sio_s.size=1; bufer[0]=NO_CMD; sio_send( &sio_s ); disk3_stat=16; }
	  }
	else
d3_write_error:
		{ sio_s.size=1; bufer[0]=DATA_OK; sio_send( &sio_s ); pause();
		  bufer[0]=DATA_ERR; sio_send( &sio_s );
		}
}

void disk3_status( void )
{  int i;
	sio_send( &sio_odpov );
	for (i=0;i<64;i++);
	bufer[0]=DATA_OK; sio_send( &sio_s );
	bufer[1]=128 | (~disk3_stat); bufer[2]=254; bufer[3]=0;
	if (disk3[cd3][7]==256) bufer[0]=32+(96-32)*disk3[cd3][4];
	else	bufer[0]=(disk3[cd3][6]==26)?128:0;
	bufer[4]=check_sum(bufer,4);
	sio_s.size=5; sio_send( &sio_s );
}

void disk3_infin( void )
{
	sio_send( &sio_odpov );
	sio_r.size=13;
	if ( sio_receive( &sio_r )==0 && bufer[12]==check_sum(bufer,12) )
		{	if ( MULu( bufer[0]*bufer[3]*(1+bufer[4]),(bufer[7]+(bufer[6]<<8)) )<=
					MULu( disk3[cd3][1]*disk3[cd3][2],disk3[cd3][3] ) )
				{	p3disk[0]=bufer[4]; p3disk[1]=bufer[0];
					p3disk[2]=bufer[3]; p3disk[3]=bufer[7]+(bufer[6]<<8);
				}
			else ini_p3disk();
			bufer[0]=DATA_OK; sio_send( &sio_s );  sio_send( &sio_s );
		}
	else	{ bufer[0]=DATA_ERR; sio_send( &sio_s );	}
}

void disk3_infout( void )
{
	sio_send( &sio_odpov );
	bufer[1]=0; bufer[2]=0; bufer[3]=p3disk[2]; bufer[4]=p3disk[0];
	bufer[5]=(p3disk[2]==18 && p3disk[3]==128)?0:4;
	bufer[6]=p3disk[3]>>8; bufer[7]=( p3disk[3] & 255 );
	bufer[8]=1; bufer[9]=65; bufer[10]=0; bufer[11]=0;
	bufer[0]=DATA_OK; sio_send( &sio_s );
	bufer[0]=p3disk[1];
	bufer[12]=check_sum( bufer, 12 );
	sio_s.size=13; sio_send( &sio_s );
}

void disk3_format( void )
{  unsigned int j,trk,sde,r;

	if (write_protect[1]==0)
		{	sio_send( &sio_odpov );
			tr_3p=-1;		/* no track in bufer */
			disk3_wrtrack=0;
			memset( bufer, 0, (8*1024) );
			for (j=disk3[cd3][0];j<(disk3[cd3][0]+disk3[cd3][1]);j++)
				{	trk=j % disk3[0][1];
					sde=DIVu( (unsigned long)j, disk3[0][1] );
					r=Flopwr( bufer, 0L, 0, 1, trk, sde, disk3[cd3][2]);
/*					printf( "\033H FRM  SIDE=%3d  TRAK=%3d   STAT=%3d ", sde,trk,r );	*/
					if (r) goto d3_form_error;
				}

			r=Floprd(bufer,0L,0,DISK3_INFO,0,0,1);
			if (r) goto d3_form_error;
			for (j=0;j<4;j++)	disk3[cd3][j+4]=p3disk[j];
			for (j=0;j<8;j++)
				bufer[cd3*8+j]=BACK_SEC( disk3[cd3][j] );
			r=Flopwr(bufer,0L,0,DISK3_INFO,0,0,1);
			if (r) goto d3_form_error;

			for (j=0;j<disk3[cd3][7];j++)	bufer[j]=0;
			bufer[0]=DATA_OK; sio_send( &sio_s );
			for (j=0;j<4;j++)	bufer[j]=255;
			bufer[disk3[cd3][7]]=check_sum(bufer,disk3[cd3][7]);
			sio_s.size=disk3[cd3][7]+1; sio_send( &sio_s );
			disk3_stat=0;
			vypis3();
		}
	else
		{	odpoved=NO_CMD; sio_send( &sio_odpov ); odpoved=CMD_OK;
		}
	return;
d3_form_error:
	bufer[0]=DATA_ERR; sio_send( &sio_s );
	disk3_stat=64+16;
}

void disk3_main( byte cmd, byte aux1, byte aux2 )
{  int sec;
/*	printf( "\033H 3 1/2 CMD=%d AUX1=%d AUX2=%d ", cmd,aux1,aux2 ); */
	sec=aux1+(aux2<<8);
	if ( cd3>0 && cd3<=disk3[0][2] )
		{	set_sio( cmd & 0x80 );
			sio_s.size=1;
			switch (cmd & 0x7f)
				{	case 82: ini_p3disk(); disk3_read(sec); break;
					case 87: ini_p3disk(); disk3_write(sec,0); break;
					case 80: ini_p3disk(); disk3_write(sec,1); break;
					case 83: disk3_status(); break;
					case 78: ini_p3disk(); disk3_infout(); break;
					case 79: disk3_infin(); break;
					case 33: disk3_format(); break;
					case 34: 	p3disk[0]=0;p3disk[1]=40;p3disk[2]=26;p3disk[3]=128;
								disk3_format(); break;
					default: odpoved=NO_CMD; sio_send( &sio_odpov ); odpoved=CMD_OK;
				}
		}
	povel=0;
}

/*--------- DISK 5 1/4 ----------*/
byte check_neg_sum( byte *buf, int dl)
{ register int sum=0;
  register byte *end=buf+dl;

  	while ( buf < end )
  		{	sum += (*buf++=~(*buf));	/* ide !!! */
  			if ( sum >= 256 ) sum= (sum+1)&0xff;
  		}
  	return ( (byte)sum );
}

void buf_neg( byte *buf, int dl)
{ register byte *end=buf+dl;
	while ( buf < end )
		*buf++=~(*buf);
}

unsigned disk5_nast_sec( unsigned sec, unsigned *sde, unsigned *trk )
{  unsigned sek,track;
   register unsigned long pom;

	track= (unsigned)(pom= DIV_MOD( (unsigned long)--sec,disk5[cs5][2] ));
	sek= (unsigned)SWAP(pom)+1;	/* modulo */
	*sde= (unsigned)(pom= DIV_MOD( (unsigned long)track, disk5[cs5][1] ));
	track= (unsigned)SWAP(pom);	/* modulo */
	if (*sde)
		{ track=disk5[cs5][1]-track-1; sek=disk5[cs5][2]-sek+1; }
	*trk=track;
	return (sek);
}

void disk5_read( int sec )
{  unsigned int i,sde,trk,sek;
   register int stat;

	sio_send( &sio_odpov );
d5_read_retry:
	if ( sec<=disk5_max && sec >0 )
		{	sek=disk5_nast_sec( sec, &sde, &trk );
/*			printf( "\033H 5 1/4 SIDE=%3d TRACK=%3d SECTOR=%3d ", sde, trk, sek );	*/
d5_read_retrsec:
			if ( (stat=(int)read_sector( 1, (sde ^ cs5), trk, sek, 1))<0 )
				{	if (trk>=40)
						{ disk5[cs5][1]=40; vypis5(); goto d5_read_retry; }
					if (sde)
						{	if ( read_sector(  1, 1, 20, 18, 1)<0 )
								{ disk5[cs5][0]=0; enable_5(); vypis5(); goto d5_read_retry; }
							if ( sek>18 || trk>39 )
								{ disk5[cs5][1]=40; disk5[cs5][2]=18;
								  disk5[cs5][3]=256, vypis5(); goto d5_read_retry;
								}
						}
					if (sek>26)
						{ disk5[cs5][2]=26; vypis5(); goto d5_read_retry; }
					if (sek>18)
						{ disk5[cs5][2]=18; vypis5(); goto d5_read_retry; }
					goto d5_read_error;
				}
			if (stat != disk5[cs5][3])
				{	if (stat == 128)
						{ disk5[cs5][3]=128; disk5[cs5][2]=26; disk5[cs5][0]=0; enable_5(); vypis5(); goto d5_read_retry; }
					if (stat == 256)
						{ disk5[cs5][3]=256; disk5[cs5][2]=18;
						  if (cs5==0)	{ disk5[cs5][0]=1; disable_5(); }
						  else	{ disk5[cs5][0]=0; enable_5(); }
						  vypis5(); goto d5_read_retry;
						}
/*					printf( "\033H 5 1/4 STAT=%3d \033H      ",stat );	*/
					goto d5_read_retrsec;
				}
/*			printf( "\033H 5 1/4 STAT=%3d DLZKA=%3d TRACK=%3d  TRK=%3d ",gl_pom,stat,disk_track[1],trk );	*/
			i=bufer[0]; bufer[0]=DATA_OK; sio_send( &sio_s ); bufer[0]=i;
			if (sec<=3) stat=128;
			disk5_stat=0;
			bufer[stat]=check_neg_sum(bufer,stat);
			sio_s.size=stat+1; sio_send( &sio_s );
		}
	else
		{	pause(); bufer[0]=NO_CMD; sio_send( &sio_s ); disk5_stat=-stat;
		}
	return;
d5_read_error:
		{	bufer[0]=DATA_ERR; sio_send( &sio_s ); disk5_stat=-stat;
		}
}

void disk5_write( int sec, int x )
{  unsigned j,sde,trk,sek;
   int stat;
	sio_send( &sio_odpov );
	j=disk5[cs5][3]; if (sec<=3) j=128;
	sio_r.size=j+1;
	if ( sio_receive( &sio_r )==0 && bufer[j]==check_sum(bufer,j) && write_protect[2]==0 )
	  {	sio_s.size=1; sek=bufer[0]; bufer[0]=DATA_OK; sio_send( &sio_s ); bufer[0]=sek;
		sek=disk5_nast_sec( sec, &sde, &trk );
	  	if ( sec<=disk5_max && sec >0 )
	  		{	buf_neg( bufer, j );
	  			if (sec<=3)	memcpy( &bufer[128], bufer, 128 );
		  		if ( (stat=(int)write_sector( 1, (sde ^ cs5), trk, sek, 1))<0 )
		  			{ disk5_stat=-stat; goto d5_write_error; }
				disk5_stat=0;
				if (x==0)	/* 0-WRITE / PUT */
					{	if ( (stat=(int)read_sector(  1, (sde ^cs5), trk, sek, 1))==disk5[cs5][3] )
							 {	bufer[0]=DATA_OK; sio_send( &sio_s );	}
						else {	bufer[0]=DATA_ERR; sio_send( &sio_s );
								if (stat<0)	disk5_stat=-stat;
								else	disk5_stat=8;
							 }
					}
				else	{ bufer[0]=DATA_OK; sio_send( &sio_s ); }
			}
		else	{ sio_s.size=1; bufer[0]=DATA_OK; sio_send( &sio_s ); pause();
				  bufer[0]=NO_CMD; sio_send( &sio_s ); disk5_stat=16;
				}
	  }
	else
d5_write_error:
		{ sio_s.size=1; bufer[0]=DATA_ERR; sio_send( &sio_s );	}
}

void disk5_status( void )
{  int i;
	sio_send( &sio_odpov );
	for (i=0;i<64;i++);
	bufer[0]=DATA_OK; sio_send( &sio_s );
	bufer[1]=128 | (~disk5_stat); bufer[2]=254; bufer[3]=0;
	if (disk5[cs5][3]==256) bufer[0]=32+(96-32)*disk5[cs5][0];
	else	bufer[0]=(disk5[cs5][2]==26)?128:0;
	bufer[4]=check_sum(bufer,4);
	sio_s.size=5; sio_send( &sio_s );
}

void disk5_infin( void )
{
	sio_send( &sio_odpov );
	sio_r.size=13;
	if ( sio_receive( &sio_r )==0 && bufer[12]==check_sum(bufer,12) )
		{	disk5[cs5][1]=40;
			if ( bufer[4]==1 )
				{	disk5[cs5][0]=1;
					disk5[cs5][2]=18;
					disk5[cs5][3]=256;
				}
			else if ( bufer[6]==1 )
				{	disk5[cs5][0]=0;
					disk5[cs5][2]=18;
					disk5[cs5][3]=256;
				}
			else if ( bufer[3]>18 )
				{	disk5[cs5][0]=0;
					disk5[cs5][2]=26;
					disk5[cs5][3]=128;
				}
			else
				{	disk5[cs5][0]=0;
					disk5[cs5][2]=18;
					disk5[cs5][3]=128;
				}
/*			disk5[cs5][0]=bufer[4]; disk5[cs5][1]=bufer[0];
			disk5[cs5][2]=bufer[3]; disk5[cs5][3]=bufer[7]+(bufer[6]<<8);
*/
			bufer[0]=DATA_OK; sio_send( &sio_s );  sio_send( &sio_s );
			vypis5();
		}
	else	{ bufer[0]=DATA_ERR; sio_send( &sio_s );	}
}

void disk5_infout( void )
{
	sio_send( &sio_odpov );
	bufer[1]=0; bufer[2]=0; bufer[3]=disk5[cs5][2]; bufer[4]=disk5[cs5][0];
	bufer[5]=(disk5[cs5][2]==18 && disk5[cs5][3]==128)?0:4;
	bufer[6]=disk5[cs5][3]>>8; bufer[7]=( disk5[cs5][3] & 255 );
	bufer[8]=1; bufer[9]=65; bufer[10]=0; bufer[11]=0;
	bufer[0]=DATA_OK; sio_send( &sio_s );
	bufer[0]=disk5[cs5][1];
	bufer[12]=check_sum( bufer, 12 );
	sio_s.size=13; sio_send( &sio_s );
}

void disk5_format( int x )
{  int pos,i,sec,sek,stat;
   unsigned pom;
   int adr_track[40];
   byte	ret_bufer[2888];
   int interleave;

	if ( (disk5[cs5][0]==1 && cs5==1) || write_protect[2]!=0 )
		{ odpoved=NO_CMD; sio_send( &sio_odpov ); odpoved=CMD_OK; }
	else
		{	interleave=6;
			if ( disk5[cs5][3]==128 || (disk5[cs5][3]==256 && x>0) )
				interleave=2;
			sio_send( &sio_odpov );
			pos=0;
			for (i=0;i<60;i++)	bufer[pos++]=0x4e;
			sec=1;
			for (sek=1;sek<=disk5[cs5][2];sek++)
				{	for (i=0;i<12;i++)	bufer[pos++]=0x00;
					for (i=0;i<3;i++)	bufer[pos++]=0xf5;
					bufer[pos++]=0xfe;
					adr_track[sec]=pos;
					bufer[pos++]=0; bufer[pos++]=0;
					bufer[pos++]=sec; bufer[pos++]=LENGH_SEC(disk5[cs5][3]);
					bufer[pos++]=0xf7;
					for (i=0;i<22;i++)	bufer[pos++]=0x4e;
					for (i=0;i<12;i++)	bufer[pos++]=0x00;
					for (i=0;i<3;i++)	bufer[pos++]=0xf5;
					bufer[pos++]=0xfb;
					for (i=0;i<disk5[cs5][3];i++)	bufer[pos++]=0xff;
					bufer[pos++]=0xf7;
					for (i=0;i<24;i++)	bufer[pos++]=0x4e;
					sec+=interleave;
					if (sec>disk5[cs5][2])
						sec=sec-disk5[cs5][2]+1;
				}
			for (i=0;i<1024;i++)	bufer[pos++]=0x4e;
			for (i=0;i<disk5[cs5][1];i++)
				{	for (sec=1;sec<=disk5[cs5][2];sec++)
						bufer[adr_track[sec]]=i;
					if ((stat=(int)write_track( 1, cs5, i ))<0)
						goto d5_format_error;
				}
			if (disk5[cs5][0]==1)
				{	for( sec=1;sec<=disk5[cs5][2];sec++ )
						{	bufer[adr_track[sec]+1]=1;
							bufer[adr_track[sec]+2]=disk5[cs5][2]-sec+1;
						}
					for (i=disk5[cs5][1]-1;i>=0;i--)
						{	for (sec=1;sec<=disk5[cs5][2];sec++)
								bufer[adr_track[sec]]=i;
							if ((stat=(int)write_track( 1, 1, i ))<0)
								goto d5_format_error;
						}
				}
			pos=0;
			memset( ret_bufer, 0, 1024 );
			if ( !speedy[2] )
				{	for (i=0;i<disk5[cs5][1];i++)
						if ( read_sector( 1, cs5, i, 1, disk5[cs5][2] )<disk5[cs5][3]*disk5[cs5][2] )
							{	disk_track[1]=i;
								for (sec=1;sec<=disk5[cs5][2];sec++)
									if (read_sector( 1,cs5,i,sec,1))
										{	pom=i*disk5[cs5][2]+sec;
											ret_bufer[pos++]=(byte)pom; ret_bufer[pos++]=(pom>>8);
										}
							}
					if (disk5[cs5][0]==1)
						for (i=disk5[cs5][1]-1;i>=0;i--)
							if ( read_sector( 1, 1, i, 1, disk5[cs5][2] )<disk5[cs5][3]*disk5[cs5][2] )
								{	disk_track[1]=i;
									for (sec=1;sec<=disk5[cs5][2];sec++)
										if (read_sector( 1, 1,i,sec,1))
											{	pom=(2*disk5[cs5][1]*disk5[cs5][2])-(i*disk5[cs5][2]+sec)+1;
												ret_bufer[pos++]=(byte)pom; ret_bufer[pos++]=(pom>>8);
											}
								}
				}
			ret_bufer[pos++]=255;ret_bufer[pos++]=255;
			ret_bufer[pos++]=255;ret_bufer[pos++]=255;
			bufer[0]=DATA_OK; sio_send( &sio_s );
			memcpy( bufer, ret_bufer, 1024L );
			bufer[disk5[cs5][3]]=check_sum( bufer, disk5[cs5][3] );
			sio_s.size=disk5[cs5][3]+1; sio_send( &sio_s );
		}
	return;
d5_format_error:
	disk5_stat=-stat;
	bufer[0]=DATA_ERR; sio_send( &sio_s );
}

void disk5_main( byte cmd, byte aux1, byte aux2 )
{  int sec;
	sec=aux1+(aux2<<8);
/*	printf( "\033H 5 1/4 CMD=%d AUX1=%d AUX2=%d SEC=%5d", cmd,aux1,aux2,sec );	*/
	set_sio( cmd & 0x80 );
	sio_s.size=1;
	switch (cmd & 0x7f)
		{	case 82: disk5_read(sec); select_B=1; break;
			case 87: disk5_write(sec,0); select_B=1; break;
			case 80: disk5_write(sec,1); select_B=1; break;
			case 83: disk5_status(); break;
			case 78: disk5_infout(); break;
			case 79: disk5_infin(); break;
			case 33: disk5_format( cmd & 0x80 ); break;
			case 34: 	disk5[cs5][0]=0;disk5[cs5][1]=40;disk5[cs5][2]=26;disk5[cs5][3]=128;
						disk5_format( cmd & 0x80 ); vypis5(); break;
			default: odpoved=NO_CMD; sio_send( &sio_odpov ); odpoved=CMD_OK;
		}
	povel=0;
}

void xf_main( void )
{ int mech;

	if ( povel_buf[5]==0 )
	{
next_povel:
		if ( povel_buf[4]==check_sum( povel_buf, 4 ) )
			{	mech=povel_buf[0]-49+1;
				if ( tab_dx[0]==mech )
					ram_main(povel_buf[1],povel_buf[2],povel_buf[3]);
				else if ( tab_dx[1]==mech )
					disk3_main(povel_buf[1],povel_buf[2],povel_buf[3]);
				else if ( tab_dx[2]==mech )
					disk5_main(povel_buf[1],povel_buf[2],povel_buf[3]);
				else 
					povel=0;
/*					printf( "\033H HEAD: %3d  %3d  %3d  %3d ",povel_buf[0],povel_buf[1],povel_buf[2],povel_buf[3] );	*/
			}
		else
			povel=0;
	}
	else
		{	povel=0; printf( "\033H E%i\033H  ",(signed)povel_buf[5]); }
/*	Ongibit( 0x20 );		* strobe=1  vystup */

}

/*--------------- main -----------------*/

int main( void )
{ register int delay=0, ko=0;
  int exit=0;
  int mox,moy,but,stat,obj;

  { int e=-3;
	if ( (e=gem_on())!=0 || !inic( "XF551.RSC" ) )	return(e);
  }
  vector_enable();
  objc_draw( t_main ,0,10,mx,my,mw,mh );
  write_protect[0]=0; write_protect[1]=0; write_protect[2]=0;
  speedy[0]=0; speedy[1]=0; speedy[2]=0;
  disable_3( 0 );
  vypis3(); vypis5(); vypisr();

  do
  {
	vq_mouse( handle, &stat, &mox, &moy );

	do	{
cont:		if ( povel )
				{
					if ( !delay )
						{ ko=1; delay_sel=DELAY_SEL;
						  v_hide_c( handle );	/* Kurzor vypn */
						  ikbd_off;			 	/* vyp. kl. proc. */
						  vbl_off;
						}
					xf_main(); delay=0x7700; goto cont;
				}
		} while ( delay ? --delay : 0 );

	if ( ko )
		{ ko=0; vbl_on; ikbd_on;		/* zap. kl. proc. */
		  v_show_c( handle, 1 );		/* Zapn kurzor */
		  if (disk3_wrtrack)	disk3_rewr();
		}

	if ( select_B && (delay_sel ? !(delay_sel--):1) )
		unselect_B();

	if ( stat==1 && (obj=objc_find( t_main, 0, 10, mox, moy))>0 )
		{
			form_button( t_main, obj, 1, &but );
			if ( but )
				exit=do_main( but );
			else
				do_main( obj );		/* unselect */
		}
  } while ( !exit );
  vector_disable();
  rsrc_free();
  gem_off();
  return(0);
}
